
; malloc.h:
;	Coypright (c) 2018-2020, Gordon Henderson

; Functions

.ifndef	mallocS
.import		mallocSetup
.import		malloc
.import		free
.import		mallocMap
.endif

; Error codes

meOK		=	0		; No error
meZero		=	1		; Zero length passed in
meOOM		=	2		; Out of memory
meBadFree	=	3		; Bad pointer passed to free


.macro	doMalloc size
	lda	#<size
	sta	$0
	lda	#>size
	sta	$1
	jsr	malloc
	jsr	strout
	.asciiz	"@ "
	lda	$1
	jsr	oHex8
	lda	$0
	jsr	oHex8
	jsr	osNewl
	jsr	mallocMap
.endmacro

.macro	doFree	pointer
	lda	#<pointer
	sta	$0
	lda	#>pointer
	sta	$1
	jsr	free
	jsr	mallocMap
.endmacro

