
; malloc.h:
;	Coypright (c) 2018-2020, Gordon Henderson

; Zero page usage
;	These shadow the sweet16 registers

; These defines don't work - will leave them in in-case I'm doing something stupid though

.define	tmpR		R1
.define reg8		R2		; Holds constant 8
.define	inOutR		R3		; Inout/Output and temp register
.define	heapStartR	R4		; The start address of our heap - typically 'lomem'
.define	chunkPtrR	R5
.define	chunkPtrNewR	R6
.define	mallocSizeR	R7		; Holds size of the chunk we want to allocate
.define	mallocSize8R	R8		; Size + 8
.define	mallocTmpR	R9
.define	mallocT2R	R10

heapStart	=	$08			; r4
heapStartL	=	heapStart+0
heapStartH	=	heapStart+1

chunkPtr	=	heapStart+2		; r5
chunkPtrL	=	chunkPtr+0
chunkPtrH	=	chunkPtr+1

chunkPtrNew	=	heapStart+4		; r6
chunkPtrNewL	=	chunkPtrNew+0
chunkPtrNewH	=	chunkPtrNew+1

mallocSize	=	heapStart+6		; r7
mallocSizeL	=	mallocSize+0
mallocSizeH	=	mallocSize+1

mallocSize8	=	heapStart+8		; r8
mallocSize8L	=	mallocSize8+0
mallocSize8H	=	mallocSize8+1

mallocTmp	=	heapStart+10		; r9
mallocTmpL	=	mallocTmp+0
mallocTmpH	=	mallocTmp+1

mallocT2	=	heapStart+12		; r10
mallocT2L	=	mallocT2+0
mallocT2H	=	mallocT2+1
